---
title: stroke-linecap
slug: Web/SVG/Attribute/stroke-linecap
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>stroke-linecap</code></strong> attribute is a presentation attribute defining the shape to be used at the end of open subpaths when they are stroked.</p>

<p class="note"><strong>Note:</strong> As a presentation attribute <code>stroke-linecap</code> can be used as a CSS property.</p>

<p>As a presentation attribute, it can be applied to any element but it has effect only on the following eight elements: {{SVGElement('altGlyph')}}, {{SVGElement('path')}}, {{SVGElement('polyline')}}, {{SVGElement('line')}}, {{SVGElement('text')}}, {{SVGElement('textPath')}}, {{SVGElement('tref')}}, and {{SVGElement('tspan')}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 6 6" xmlns="http://www.w3.org/2000/svg"&gt;

  &lt;!-- Effect of the (default) "butt" value --&gt;
  &lt;line x1="1" y1="1" x2="5" y2="1" stroke="black"
        stroke-linecap="butt" /&gt;

  &lt;!-- Effect of the "round" value --&gt;
  &lt;line x1="1" y1="3" x2="5" y2="3" stroke="black"
        stroke-linecap="round" /&gt;

  &lt;!-- Effect of the "square" value --&gt;
  &lt;line x1="1" y1="5" x2="5" y2="5" stroke="black"
        stroke-linecap="square" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;path d="M1,1 h4 M1,3 h4 M1,5 h4" stroke="pink" stroke-width="0.025" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('topExample', '100%', 200)}}</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>butt</code> | <code>round</code> | <code>square</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>butt</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>discrete</td>
  </tr>
 </tbody>
</table>

<h3 id="butt">butt</h3>

<p>The <code>butt</code> value indicates that the stroke for each subpath does not extend beyond its two endpoints. On a zero length subpath, the path will not be rendered at all.</p>

<h4 id="Example">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 6 4" xmlns="http://www.w3.org/2000/svg"&gt;

  &lt;!-- Effect of the "butt" value --&gt;
  &lt;path d="M1,1 h4" stroke="black"
        stroke-linecap="butt" /&gt;

  &lt;!-- Effect of the "butt" value on a zero length path --&gt;
  &lt;path d="M3,3 h0" stroke="black"
        stroke-linecap="butt" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;path d="M1,1 h4" stroke="pink" stroke-width="0.025" /&gt;
  &lt;circle cx="1" cy="1" r="0.05" fill="pink" /&gt;
  &lt;circle cx="5" cy="1" r="0.05" fill="pink" /&gt;
  &lt;circle cx="3" cy="3" r="0.05" fill="pink" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('butt', '100%', 200)}}</p>

<h3 id="round">round</h3>

<p>The <code>round</code> value indicates that at the end of each subpath the stroke will be extended by a half circle with a diameter equal to the stroke width. On a zero length subpath, the stroke consists of a full circle centered at the subpath's point.</p>

<h4 id="Example_2">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 6 4" xmlns="http://www.w3.org/2000/svg"&gt;

  &lt;!-- Effect of the "round" value --&gt;
  &lt;path d="M1,1 h4" stroke="black"
        stroke-linecap="round" /&gt;

  &lt;!-- Effect of the "round" value on a zero length path --&gt;
  &lt;path d="M3,3 h0" stroke="black"
        stroke-linecap="round" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;path d="M1,1 h4" stroke="pink" stroke-width="0.025" /&gt;
  &lt;circle cx="1" cy="1" r="0.05" fill="pink" /&gt;
  &lt;circle cx="5" cy="1" r="0.05" fill="pink" /&gt;
  &lt;circle cx="3" cy="3" r="0.05" fill="pink" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('round', '100%', 200)}}</p>

<h3 id="square">square</h3>

<p>The <code>square</code> value indicates that at the end of each subpath the stroke will be extended by a rectangle with a width equal to half the width of the stroke and a height equal to the width of the stroke. On a zero length subpath, the stroke consists of a square with its width equal to the stroke width, centered at the subpath's point.</p>

<h4 id="Example_3">Example</h4>

<div class="hidden">
<pre class="brush: css notranslate">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html notranslate">&lt;svg viewBox="0 0 6 4" xmlns="http://www.w3.org/2000/svg"&gt;

  &lt;!-- Effect of the "square" value --&gt;
  &lt;path d="M1,1 h4" stroke="black"
        stroke-linecap="square" /&gt;

  &lt;!-- Effect of the "square" value on a zero length path --&gt;
  &lt;path d="M3,3 h0" stroke="black"
        stroke-linecap="square" /&gt;

  &lt;!--
  the following pink lines highlight the
  position of the path for each stroke
  --&gt;
  &lt;path d="M1,1 h4" stroke="pink" stroke-width="0.025" /&gt;
  &lt;circle cx="1" cy="1" r="0.05" fill="pink" /&gt;
  &lt;circle cx="5" cy="1" r="0.05" fill="pink" /&gt;
  &lt;circle cx="3" cy="3" r="0.05" fill="pink" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('square', '100%', 200)}}</p>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<p>{{Compat("svg.attributes.presentation.stroke-linecap")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "painting.html#StrokeLinecapProperty", "stroke-linecap")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Definition for shapes and texts</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "painting.html#StrokeLinecapProperty", "stroke-linecap")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition for shapes and texts</td>
  </tr>
 </tbody>
</table>
